function C = approxTriToDegreeRatio(A, t)

%%%%%% input %%%%%%
% A - Sparse adjacency matrix of graph

%%%%%% return %%%%% 
% C - cost based on g(v) = t(v)/d(v) number of triangles(v) divided by the degree(v)
% n by 1 vector where n is the number of nodes

N = length(A);

%compute degree of the nodes 
degree = full(sum(A,2));

%compute the triangle by approximation 
%C = zeros(N,1);
%tri = zeros(N,1);

%first computing all eigenvalues
if t < N
    [V, E] = eigs(A,t);
else
    [V, E] = eig(full(A));
end
%[V, E] = eig(full(A));

E = sum(E);

Etemp = E.^3;

triTemp = times(Etemp(ones(1,N),:), V.^2);
triTemp = sum(triTemp,2)/2;
Ctemp = triTemp./degree;
[row,~] = find(isnan(Ctemp));
Ctemp(row) = 0;
[row,~] = find(isinf(Ctemp));
Ctemp(row) = 0;
[row,~] = find(Ctemp < 0); 
Ctemp(row) = 0;

C = Ctemp;

% %tic
% for i=1:N
%     triI = 0;
%     for j=1:t
%         triI = triI + (E(j)^3) * V(i,j)^2;  
%     end
%     tri(i) = triI/2;
%     %[triTemp(i) tri(i)] 
%     %pause
%     if degree(i) > 0
%         
%         C(i) = (triI/2)/degree(i);
%         
%         if C(i) < 0
%             C(i) = 0;
%         end
%         
%     end
%     
%     [C(i) Ctemp(i)]
%     pause
% end
% %toc
% %tri
% %tic
% %diag(A^3)/2
% %toc

end