function [S, lambdaS] = grasp_MRS_LocalSearch(A, inputS, k)

%%%% input %%%%%%
% A - Sparse adjaceny matrix (symmetric)
% inputS - given subset of solution to improve
% k - size of the subgraph 

format longG;

more = true;

output = inputS;
S = inputS;
%samplePer = 0.5;
countr = 0;

if length(S) < 50
    [~,l] = eig(full(A(S,S)));
    lambdaS = log(1/length(l) * sum(exp(sum(l))));
else
    [~,l] = eigs(A(S,S),10);
    lambdaS = log(1/length(S) * sum(exp(sum(l))));  
end

while more
    
    
    removeSet = S;
    %removeSet = removeSet(randsample(length(removeSet),floor(samplePer*length(removeSet))));
    
        
    if ~isempty(removeSet)
        
        %r = random('unid',length(removeSet));

        bestlambda = -1;
        best = -1;
        
        for i=1:length(removeSet)
        
            tempS = setdiff(S,removeSet(i));

            if length(tempS) < 50
                [~,l] = eig(full(A(tempS,tempS)));
                lambdaTempS = log(1/length(l) * sum(exp(sum(l))));
            else
                [~,l] = eigs(A(tempS,tempS),10);
                lambdaTempS = log(1/length(tempS) * sum(exp(sum(l))));
            end
            
            if lambdaTempS > bestlambda
                bestlambda = lambdaTempS;
                best = i;
            end
        end
        
        lambdaTempS = bestlambda;
        r = best;
        
        if length(S) == k
            output = S;
        end
                
        if lambdaTempS >= lambdaS
            
            S = setdiff(S,removeSet(r));
            lambdaS = lambdaTempS;
        else
            removeSet = [];
        end
        
    end
    
    if length(S) == k
        output = S;
    end
    
    
    
    if isempty(removeSet)
        more = false;
    end    
    
    
    %addSet should be neighbors of S 
    [~, J] = ind2sub(size(A(S,:)), find(A(S,:)));
    
    J = unique(J);    
    % returns the data in J that is not in S i.e J-S
    addSet = setdiff(J,S);
    
    %randomSample
    %addSet = addSet(randsample(length(addSet),floor(samplePer*length(addSet))));
    
    addCount = 0;
    numberAdded = 0;
    
    graphSize = length(S);
    
    
    
    
    while ~isempty(addSet) && graphSize < k + 1
        
        %r = random('unid',length(addSet));
        
        bestlambda = -1;
        best = -1;
        
        for i=1:length(addSet)
        
            tempS = [S; addSet(i)];

            if length(tempS) < 50
                
                [~,l] = eig(full(A(tempS,tempS)));
                lambdaTempS = log(1/length(l) * sum(exp(sum(l))));
            else
                [~,l] = eigs(A(tempS,tempS),10);
                lambdaTempS = log(1/length(tempS) * sum(exp(sum(l))));
                
            end
            
            if lambdaTempS > bestlambda
                bestlambda = lambdaTempS;
                best = i;
            end
        end
        
        
        lambdaTempS = bestlambda;
        r = best;
        
        addCount = addCount + 1;
        
        if lambdaTempS > lambdaS
            
            %numberAdded = numberAdded + 1;
            
            S = [S; addSet(r)];
            graphSize = length(S);
            lambdaS = lambdaTempS;
            %addSet(r) = [];
            %addSet should be neighbors of S    
            
                       
            %numberAdded = 0;
            [~, J] = ind2sub(size(A(S,:)), find(A(S,:)));
            
            J = unique(J);
            % returns the data in J that is not in S i.e J-S
            addSet = setdiff(J,S);
            
            %randomSample
            %addSet = addSet(randsample(length(addSet),floor(samplePer*length(addSet))));

            if length(S) == k
                output = S;
            end
            
            more = true;
            
            
        else
            %addSet(r) = [];
            addSet = [];
        end
        
    end    
    
    
    countr = countr + 1;
    
    
end

S = output;

end
